<?php
/**
 Try to avoid global defines. Use class constants when possible
 For each constant category, a new class should be created
 If a constant fits nowhere else, place it in the ConstMisc class
**/

class ConstDB {
    // This class contains all the table names
    // and other DB-related stuff

    // Database info
    const DB_TYPE                           = 'mysql';
    const DB_ADDR                           = 'localhost';
    const DB_NAME                           = 'billbasa';                    /// Change!!!
    const DB_USER                           = 'root';                       /// Change!!!
    const DB_PASS                           = 'passwd';                   /// Change!!!

    //Tables
    const TBL_LANGUAGES                     = 'languages';
    const TBL_LANGUAGES_LIST                = 'languages_list';
    const TBL_FILESPACE                     = 'filespaces';
    const TBL_SESSION_DATA                  = 'session_data';
    const TBL_MAILS                         = 'mails';
    const TBL_USERS                         = 'users';
    const TBL_BANS                          = 'bans';
    const TBL_BAN_REASONS                   = 'ban_reasons';
    const TBL_PACKETS                       = 'packets';
    const TBL_PACKET_GROUPS                 = 'packet_groups';
    const TBL_USER_PACKETS                  = 'user_packets';
    const TBL_USER_PACKET_GROUPS            = 'user_packet_groups';
    const TBL_CONFIRM_KEYS                  = 'user_confirm_keys';
    const TBL_BALANCE_HISTORY               = 'balance_history';
    const TBL_ANNOUNCEMENTS                 = 'announcements';
    const TBL_PACKET_PORTS                  = 'packet_ports';
    const TBL_SERVER_LOAD                   = 'server_load';
    const TBL_SPPI_PAYMENT_LOG              = 'sppi_payment_log';
}

class ConstEmail {
    // Email
    const ADMIN_EMAIL                       = 'support@site.ru';                     /// Change!!!
    const ADMIN_NAME                        = 'admin';                       /// Change!!!
}

class ConstPaths {
    const TEMPLATE_DIR                      = 'templates/';
    const INCLUDE_DIR                       = 'includes/';
}

class ConstSession {
    const SESSION_NAME                      = 'ssn';
    const SESSION_LIFE_TIME                 = 3600;
}

class ConstCookies {
    const COOKIE_DOMAIN                     = 'coocke';                          /// Change!!!
    const COOKIE_PATH                       = '/';
    const COOKIE_LIFE_TIME                  = 1000;
}

class ConstFormat {
    const DATE_TIME_FORMAT                  = "d.m.Y H:i:s";
    const SMARTY_DATE_TIME_FORMAT           = "%d.%m.%Y %H:%M";
    const DATE_FORMAT                       = "d.m.Y";
    const SMARTY_DATE_FORMAT                = "%d.%m.%Y";
}

class ConstTrans {
const TRANS_LOG                          = "/var/log/trans/trans.log";
const TRANS_2_LOG                        = "/var/log/trans/trans2.log";
const TRANS_3_LOG                        = "/var/log/trans/trans3.log";
const TRANS_4_LOG                        = "/var/log/trans/trans4.log";
const TRANS_5_LOG                        = "/var/log/trans/trans5.log";
const TRANS_6_LOG                        = "/var/log/trans/trans6.log";
const TRANS_7_LOG                        = "/var/log/trans/trans7.log";
const TRANS_8_LOG                        = "/var/log/trans/trans8.log";
const TRANS_9_LOG                        = "/var/log/trans/trans9.log";
const TRANS_INITSCRIPT                   = "/etc/init.d/translate";
const TRANS_SERVER_CFG_TEMPLATE_REL      = "files/server.cfg.tpl";   // relative to project root
const TRANS_2_SERVER_CFG_TEMPLATE_REL    = "files/server.cfg.tpl";   // relative to project root
const TRANS_3_SERVER_CFG_TEMPLATE_REL    = "files/server.cfg.tpl";   // relative to project root
const TRANS_4_SERVER_CFG_TEMPLATE_REL    = "files/server.cfg.tpl";   // relative to project root
const TRANS_5_SERVER_CFG_TEMPLATE_REL    = "files/server.cfg.tpl";   // relative to project root
const TRANS_6_SERVER_CFG_TEMPLATE_REL    = "files/server.cfg.tpl";   // relative to project root
const TRANS_7_SERVER_CFG_TEMPLATE_REL    = "files/server.cfg.tpl";   // relative to project root
const TRANS_8_SERVER_CFG_TEMPLATE_REL    = "files/server.cfg.tpl";   // relative to project root
const TRANS_9_SERVER_CFG_TEMPLATE_REL    = "files/server.cfg.tpl";   // relative to project root
const TRANS_SERVER_CFG                   = "/usr/local/oscam/vostok_cccam/oscam.user";
const TRANS_2_SERVER_CFG                 = "/var/etc2/oscam.user";
const TRANS_3_SERVER_CFG                 = "/var/etc3/oscam.user";
const TRANS_4_SERVER_CFG                 = "/var/etc4/oscam.user";
const TRANS_5_SERVER_CFG                 = "/var/etc5/server.cfg";
const TRANS_6_SERVER_CFG                 = "/var/etc6/server.cfg";
const TRANS_7_SERVER_CFG                 = "/var/etc7/server.cfg";
const TRANS_8_SERVER_CFG                 = "/var/etc8/server.cfg";
const TRANS_9_SERVER_CFG                 = "/var/etc9/server.cfg";
const TRANS_SERVER_COUNT                 = 6;
const OSCAM_SERVER_CFG_TEMPLATE_REL     = "files/oscam.user.tpl";   // relative to project root
const OSCAM_LOG = "/var/etc/oscam.log";
const OSCAM_SERVER_CFG = "/var/etc/oscam.user";
const OSCAM_2_SERVER_CFG = "/var/etc/oscam2.user";
const OSCAM_3_SERVER_CFG = "/var/etc/oscam3.user";
const OSCAM_4_SERVER_CFG = "/var/etc/oscam4.user";
const OSCAM_5_SERVER_CFG = "/var/etc/oscam5.user";
const OSCAM_6_SERVER_CFG = "/var/etc/oscam6.user";

const WICARD_SERVER_CFG_TEMPLATE_REL     = "files/wicard.user.tpl";   // relative to project root
const WICARD_SERVER_CFG                  = "/var/etc/wicardd1.user";
const WICARD_SERVER_COUNT                = 1;
}
		    
class ConstMisc {
    const BILLING_VERSION                   = "3.7";
    const SMARTY_DEBUG                      = false;
    const STANDARD_LANGUAGE                 = 'ru';
    const MAX_UPLOAD_SIZE                   = 50;                                   // megabytes
    const ADMIN_LOG                         = "/var/www/log/adm.log";                                // wether to write to the admin log
    const SECRET                            = "swersdsdeedfdrrerewwertytryrtbgffgg";
    const SITE_NAME                         = "CardSHARING";                               /// Change!!!
    const SITE_ADDRESS                      = "http://sharantv.ru";
    const FORUM_ADDRESS                     = "forum/";              /// Change!!!
    const SHOP_ID                           = "EEA6A6DE-1169-45A5-D2F2-A93263C";                         /// Change!!!
    const SHOP_SECRET_KEY                   = "8L5Eh6qpT";                         /// Change!!!
    const SHOP_ID1                          = "EEA6A6DE-1169-45A5-D2F2-A93263C";                         /// Change!!!
    const SHOP_SECRET_KEY1                  = "8L5Eh6qpT";                         /// Change!!!


}

class ConstSPPI {
    const SHOP_ID                           = 2220;                        /// Change!!!
    const SHOP_SECRET_KEY                   = "95ffa564";    /// Change!!!
    const SppiPaymentLog                    = "var/www/asd.log";
}
// Don't show notices
error_reporting(E_ALL ^ E_NOTICE);

// get the current work directory
$project_root = (substr(PHP_OS, 0, 3) == 'WIN') ? strtolower(dirname(__FILE__)) : dirname(__FILE__);  // a hack for winblows
define('CFG_PROJECT_ROOT', $project_root);

if (!defined ('PATH_SEPARATOR')) /// TODO: do we REALLY need this?
    define ('PATH_SEPARATOR', ((strstr (strtolower ($_SERVER['OS']), 'windows')) ? ';' : ':'));

/**
* @desc For the Smarty class
*/
if (!defined ('DIRECTORY_SEPARATOR'))
    define ('DIRECTORY_SEPARATOR', PATH_SEPARATOR);

/**
* @desc Include Path
*/
$include_path = ini_get('include_path');
ini_set ('include_path', ini_get('include_path') . PATH_SEPARATOR . CFG_PROJECT_ROOT . "/" . ConstPaths::INCLUDE_DIR);

// Now, include the standard files
require_once "StdIncludes.php";

/**
* @desc  php.ini Modification
*/
if (ini_get('register_globals'))
    ini_set ('register_globals', 'Off');
if (ini_get('magic_quotes_gpc'))
    ini_set ('magic_quotes_gpc', 'Off');
if (ini_get('output_buffering'))
    ini_set ('output_buffering', 'On');
if (ini_get('magic_quotes_runtime'))
    ini_set ('magic_quotes_runtime', 0);
// Maximal size of uploaded files
if (ini_get('post_max_size') != ConstMisc::MAX_UPLOAD_SIZE)
    ini_set ('post_max_size', ConstMisc::MAX_UPLOAD_SIZE);
if (ini_get('upload_max_filesize') != ConstMisc::MAX_UPLOAD_SIZE)
    ini_set ('upload_max_filesize', ConstMisc::MAX_UPLOAD_SIZE);

/**
* @desc clear $_POST and $_GET
**/
if ($_SERVER['REQUEST_METHOD'] == 'GET')
    Validation::clearGetVars();
elseif ($_SERVER['REQUEST_METHOD'] == 'POST')
    Validation::clearPostVars();
/**
* @desc Global Variables
*/
$sgErrorStack = array();

$ssn    =& Session::getInstance();
$lang   =& Language::getInstance();
$tpl    =& Template::getInstance();
$tpl->assign("lang", $lang);
$tpl->assign("billing_version",     ConstMisc::BILLING_VERSION);
$tpl->assign("trans_server_count",  ConstTrans::TRANS_SERVER_COUNT);

define('SMARTY_DATE_FORMAT',        ConstFormat::SMARTY_DATE_FORMAT);
define('SMARTY_DATE_TIME_FORMAT',   ConstFormat::SMARTY_DATE_TIME_FORMAT);
define('SHOP_ID',                   ConstMISC::SHOP_ID);
define('SPPI_SHOP_ID',              ConstSPPI::SHOP_ID);
$tpl->assign('VALID_ITEMS_PP', array(500, 5000));

/** Register Smarty functions */
$tpl->register_function('lang', 'bfSmartyLang');
$tpl->register_function('ssn', 'bfSmartyGetSession');
$tpl->register_function('islogin', 'smarty_isLogin');
$tpl->register_function('lnk', 'SmartyGetLink');
$tpl->register_function('link', 'smartyLink');
$tpl->register_function('req', 'SmartyRequest');
$tpl->register_function('request_uri', 'SmartyRequestURI');
$tpl->register_function ('cycle', 'cycle');
$tpl->register_function ('uniqid', 'smartyUniqid');
?>
