(function() {
	tinymce.create('tinymce.plugins.ExtImagePlugin', {
		init : function(ed, url) {
			ed.addCommand('mceExtImage', function() {
				var imageManager = new MyEngine.com.ImageManager({
					controllerUrl: this.controllerUrl || MyEngine.imageManagerControllerUrl,
					imagesRootUrl: this.imagesRootUrl || MyEngine.publicUrl,						
					selectHandler: function(dataView, index, node, e) {
						ed.dom.add(ed.getBody(), 'img', {
							src : this.imagesRootUrl + this.getImagesStore().getAt(index).get('url')
						}, ed.selection.getContent() || ed.getLang('layer.content'));
						Ext.WindowMgr.getActive().hide();
					}
				});
				
				var imageManagerWindow = new Ext.Window({
					title: 'Image Manager',
					width: 700,
					height: 400,
		            minWidth: 300,
		            minHeight: 200,
					layout: 'border',
					items: imageManager.getLayout()
				});
				
				imageManagerWindow.on('beforeshow', function(){
					this.hide();
				}, Ext.WindowMgr.getActive());
				
				imageManagerWindow.on('beforehide', function(){
					this.show();
				}, Ext.WindowMgr.getActive());
				
				imageManagerWindow.show();
			});
			ed.addButton('extimage', {title : 'Insert Image from Image Manager', cmd : 'mceExtImage'});
		},

		getInfo : function() {
			return {
				longname : 'Insert Ext image',
				author : 'Merva D.V.',
				authorurl : 'http://myengine.com.ua',
				infourl : 'http://myengine.com.ua',
				version : tinymce.majorVersion + "." + tinymce.minorVersion
			};
		}
	});
	
	// Register plugin
	tinymce.PluginManager.add('extimage', tinymce.plugins.ExtImagePlugin);
})();