<?php
require_once "LocalSettings.php";

function confirm()
{
    global $lang;

    // Проверяем GET переменные
    $login  = $_GET['login'];
    $key    = $_GET['key'];
    // Есть ли такой пользователь?
    $user = new User($login);
    if (!$user->isLoaded()){
        Messages::setUserErrorMsg($lang->get('err__no_such_user'));
        return false;
    }
    // Может быть он уже подтверждён?
    if ($user->get('confirmed')) {
        Messages::setUserMsg($lang->get('msg__user_already_confirmed'));
        return false;
    }
    // Проверяем ключ
    $confirm_key = new ConfirmKey($login);
    if (!$confirm_key->isLoaded() || $confirm_key->get('conf_key') != $key){
        Messages::setUserMsg($lang->get('msg__wrong_login_or_key'));
        return false;
    }
    // Все ОК, подтверждаем
    $user->set('confirmed', 1);
    $user->save();
    $confirm_key->delete();
    return true;
}

if (confirm())
    Messages::setUserMsg($lang->get('msg__confirm_successful'));

$tpl->assign('page_title',  $lang->get('title__register_confirmation'));
Messages::formatAll();
$tpl->assign("main_template", "User_Register_Confirmation.html");
$tpl->display("Fend_Index.html");
?>