<?php
abstract class HandledActiveRecordContainer extends ActiveRecordContainer {
    protected $items_pp;
    // При создании потомка класса было бы полезно задать
    // нужное значение
    protected $items_pp_default = 10;
    protected $page;
    const HANDLER_SESSION_BASE = "PageHandlerData";
    // Если нужны дополнительные условия
    protected $conditions = "";
    // Не забыть переопределить $default_order_by!!

    public function HandledActiveRecordContainer($place = "", $order_by = "", $order_asc = true)
    {
        $this->_construct($place, $order_by, $order_asc);
        $this->initialPageVars($place);
    }

    public function getPage()
    {
        return $this->page;
    }

    public function getItemsPP()
    {
        return $this->items_pp;
    }

    protected function initialPageVars($place)
    {
        if (isset($_GET['items_pp'])){
            $this->items_pp = intval($_GET['items_pp']);
        } else
            $this->items_pp = $this->getHandlerSessionVar('items_pp');
        if ($this->items_pp <= 0){
            $this->items_pp = $this->items_pp_default;
        }
        $this->setHandlerSessionVar('items_pp', $this->items_pp);
        if (isset($_GET['page'])){
            $this->page = intval($_GET['page']);
        } else
            $this->page = $this->getHandlerSessionVar('page');
        if ($this->page < 1)
            $this->page = 1;
        $this->setHandlerSessionVar('page', $this->page);
    }

    protected function getLimit()
    {
        $start = intval($this->getHandlerSessionVar('start'));
        if ($start < 0)
            $start = 0;
        return (" LIMIT " . $start . ", " . $this->getHandlerSessionVar('items_pp'));
    }

    protected function getLoadSQL($count = false, $conditions = "")
    {
        $sql = ($this->getSQL($count) . $conditions . ($count ? "" : ($this->getOrderBy() . $this->getLimit())));
        return $sql;
    }

    public function loadAll()
    {
        $ph = $this->pageHandler();
        parent::loadAll();
        return $ph;
    }

    public function pageHandler()
    {
        $db = new Database(get_class($this) . "::pageHandler");
        $sql = $this->getLoadSQL(true, $this->conditions);
        $db->query($sql);
        if ($db->nextRecord()) {
            $numRows = $db->f('num_rows');
        }
        if ($this->page < 1)
            $this->page = 1;
        $start = ($this->page - 1) * $this->items_pp;
        if ($start >= $numRows){
            $this->page = ceil($numRows / $this->items_pp);
            $start = ($this->page - 1) * $this->items_pp;
        }
        $this->setHandlerSessionVar('start', $start);
        if ($numRows > $this->items_pp){
            foreach ($_GET AS $k => $v) {
                if ($k != 'page') {
                    $get .= "$k=$v&";
                }
            }
            $get = preg_replace ( "/&$/", "", $get );
            $pH = PageHandlers::stdPageHandler($_SERVER['PHP_SELF'], $get, $this->items_pp, $numRows, $this->page);
            return $pH;
        }
        return;
    }



    public function resetPageHandler()
    {
        $this->setHandlerSessionVar('page', 1);
        $this->setHandlerSessionVar('start', 0);
    }

    protected function getHandlerSessionVar($var)
    {
        return $_SESSION[self::HANDLER_SESSION_BASE][get_class($this)][$this->place][$var];
    }

    protected function setHandlerSessionVar($var, $value)
    {
        $_SESSION[self::HANDLER_SESSION_BASE][get_class($this)][$this->place][$var] = $value;
    }
}
?>