<?php

    class Language {
        var $lang;
        var $db;
        var $skip_load;
        var $cliches = array();
        var $languages = array();

        function Language($std_lang = '', $skip_load = false)
        {
            $this -> cliches = array();
            $this -> loadLanguages();
            if (!empty($std_lang)) {
                $this->lang = $std_lang;
            } else {
                $this->detectLanguage();
            }
            $_SESSION['selected_lang'] = $this -> lang;
            $this -> db =& DB_MySQL::getInstance();
            if ($this->lang == 'ru'){
                $res = setlocale(LC_TIME, 'ru_RU.UTF-8');
            } elseif ($this->lang == 'lv'){
                $res = setlocale(LC_TIME, 'lv_LV.UTF-8');
            }
            //if ( !skip_load )
            $this -> load();
        }

        function detectLanguage()
        {
            if ( isset( $_GET['lang'] ) && isset ( $this->languages[$_GET['lang']] ) ) {
                $this -> lang = $_GET['lang'];
                if ( !isset( $_COOKIES['lang'] ) || $this->lang != $_COOKIES['lang'] ) {
                    setcookie( 'lang', $this -> lang, time() + (ConstCookies::COOKIE_LIFE_TIME), '/', '.' . ConstCookies::COOKIE_DOMAIN );
                }
            } elseif ( isset( $_POST['lang'] ) && isset ( $this->languages[$_POST['lang']] ) ) {
                $this -> lang = $_POST['lang'];
                if ( !isset( $_COOKIES['lang'] ) || $this->lang != $_COOKIES['lang'] ) {
                    setcookie( 'lang', $this -> lang, time() + (ConstCookies::COOKIE_LIFE_TIME), '/', '.' . ConstCookies::COOKIE_DOMAIN );
                }
            } elseif ( isset( $_SESSION['selected_lang'] ) && isset ( $this->languages[$_SESSION['selected_lang']] ) ) {
                $this -> lang = $_SESSION['selected_lang'];
            } elseif ( isset( $_COOKIE['lang'] ) && isset ( $this->languages[$_COOKIE['lang']] ) ){
                $this -> lang = $_COOKIE['lang'];
            } else {
                $this -> lang = ConstMisc::STANDARD_LANGUAGE;
            }
        }

        function loadLanguages()
        {
            $this->languages = array();
            $sql_str =    "SELECT * " .
                            "   FROM " . ConstDB::TBL_LANGUAGES_LIST;
            $this -> db =& DB_MySQL::getInstance();
            $this->db->query($sql_str);
            if ( $this->db->numRows() < 1 )
                return false;
            while ( $this->db->nextRecord() ) {
                $this->languages[$this->db->f( 'lang_id' )] =  array('lang_name'             => $this->db->f( 'lang_name' ),
                                                                    'lang_name_localized'   => $this->db->f( 'lang_name_localized' ) );
            }
        }

        function getLanguages()
        {
            //$this->loadLanguages();
            return $this->languages;
        }

        function getLang()
        {
            return $this->lang;
        }

        function load($reload = false, $load_all = false)
        {
            if ( $reload ){
                $this -> cliches = array();
                $this->detectLanguage();
            }

            $sql = $this -> getLoadSQL(false, $load_all);
            $this -> db -> query( $sql );
            while ( $this -> db -> nextRecord() ) {
                $this -> cliches[$this -> db ->f ( 'name_alias' )] = stripslashes( $this -> db -> f( 'value_' . $this -> lang ) );
                //print $this -> db ->f ( 'name_alias' ) . "  " . $this -> db -> f( 'value_' . $this -> lang ) . "<br>";
            }
            //print_r( $this -> cliches );
        }

        function getLoadSQL( $count = false, $load_all = false)
        {
            if ( $count )
                $sql_start = " SELECT COUNT(*) ";
            else
                $sql_start = " SELECT * ";

            $sql  = $sql_start . " FROM " . ConstDB::TBL_LANGUAGES;
            if (!$load_all)
                $sql .= " WHERE def_load = '1' ";
            return $sql;
        }

        function exists ($key)
        {
            if (array_key_exists($key, $this->cliches))
                return TRUE;
            else
                return FALSE;
    }

        function get ($key, $vars = null, $utf8 = false)
        {
            //print_r( $this -> cliches );
            $val = $this->cliches[$key];
                //print_r( $this );
                if ( empty( $val ) )
                    $val = $key;

                if (is_array($vars))
                    foreach ($vars as $k => $v)
                        $val = str_replace ('$' . $k, $v, $val);

                $ret = ($utf8) ? utf8_encode($val) : $val;

                return $ret;
        }
        static function &getInstance($std_lang = '')
        {
            static $lang;

            if (!is_object($lang))
                $lang = new Language($std_lang);

            return $lang;
        }
        function Lang ()
        {
            return $this->lang;
        }
    }
?>