<?php
require_once ('HtmlMimeMail/HtmlMimeMail.php');

class Mail extends htmlMimeMail {

    var $mail_languages = array();
    var $mail_text = array();
    var $mail_subj = array();

    function Mail()
    {
        $this->getLanguages();
    }

    function getLanguages()
    {
        $this->mail_languages = array();
        $db =& DB_MySQL::getInstance();
        $sql_str =    " SELECT lang_id " .
                      " FROM " . ConstDB::TBL_LANGUAGES_LIST;
        $db->query($sql_str);
        while ($db->nextRecord()) {
            array_push( $this->mail_languages, $db->f('lang_id') );
        }
    }

    function mailExsists( $mail_ailas )
    {
        $sql  = " SELECT COUNT(*) as num_rows ";
        $sql .= " FROM " . ConstDB::TBL_MAILS;
        $sql .= " WHERE alias = '" . $mail_ailas . "'";

        $db =& DB_MySQL::getInstance();

        $db->query( $sql );

        if ( $db->nextRecord() ) {
            $num_rows = $db->f('num_rows');
            if ( $num_rows > 0 ) return true;
        }
        return false;
    }

    function formatedMail( $data, $vars = array() )
    {
        $mails_text = array();
        $txt  = $data;
        if ( $vars == array() )
            return $data;

        foreach ($vars as $key => $val) {
           $txt  = str_replace ( '$'.$key, strip_tags($val), $txt );
        }
        return $txt;
    }

    function getMail( $mail_alias )
    {
        $sql  = " SELECT *";
        $sql .= " FROM " . ConstDB::TBL_MAILS;
        $sql .= " WHERE alias = '" . $mail_alias . "'";

        $db =& DB_MySQL::getInstance();

        $db->query( $sql );

        if ( $db->nextRecord() ) {
            $this->mail_text[$mail_alias] = array();
            foreach( $this->mail_languages as $lang ) {
                $this->mail_subj[$mail_alias][$lang] = $db->f( 'subj_' . $lang);
                $this->mail_text[$mail_alias][$lang] = $db->f( 'text_' . $lang);
            }
        }
    }

    function sendMail ($email, $mail_alias, $lang = ConstMisc::STANDARD_LANGUAGE, $vars = array(), $from_name = '', $from_email = '' )
    {
        $this->setTextCharset('UTF-8');
        $this->setHeadCharset('UTF-8');

        if ( empty( $this->mail_text[$mail_alias] ) ) {
            if ( $this->mailExsists( $mail_alias ) ) {
                $this->getMail( $mail_alias );
            } else return -1; //mail not found
        }
        //See if the mail exists in the selected language
        if ( empty( $this->mail_text[$mail_alias][$lang] ) ) {
            if ( empty( $this->mail_text[$mail_alias][ConstMisc::STANDARD_LANGUAGE] ) ) {
                return -2; //mail doesn't exist in current AND the standard language
            } else {
                $lang = ConstMisc::STANDARD_LANGUAGE;
            }
        }

        //get the standard footer
        if ( empty( $this->mail_text['std_footer'] ) ) {
            if ( $this->mailExsists( 'std_footer' ) ) {
                $this->getMail( 'std_footer' );
            }
        }

        $mails_text = $this->mail_text[$mail_alias][$lang];
        $mails_text = $this->formatedMail($mails_text, $vars);
        $subject = $this->mail_subj[$mail_alias][$lang];
        if (Messages::userErrorsEx()  < 1) {
            $this->setReturnPath(ConstEmail::ADMIN_EMAIL);

            if ($from_email == '') {
                $this->setFrom(ConstEmail::ADMIN_NAME . ' <' . ConstEmail::ADMIN_EMAIL . '>');
            } else {
                $this->setFrom($from_name.' <'. $from_email .'>');
            }

            $this->setSubject($subject);
            $this->setHeader('X-Mailer', 'HTML Mime mail class (HTMLMimeMail)');

            $this->setText($mails_text);
            $res = $this->send( array($email) );
            if (!$res) {
                Messages::setMailMsg('Email to ' . $email . ' has not been sent!', __FILE__, __LINE__);
                Messages::setLogMsg('Email to ' . $email . ' has not been sent!', __FILE__, __LINE__);
                Messages::setUserErrorMsg('Email to ' . $email . ' has not been sent!');
            }
            return $res;
        } else {
            return false;
        }
    }
}

?>