<?php

class MoneyBox
{
    protected $sum_month = 0.0;
    protected $sum_total = 0.0;
    protected $share = 0.1;
    protected $month_start;
    protected $month_end;

    public function __construct()
    {
        $this->load();
    }

    protected function load()
    {
        $this_month_num = date("n");
        $this->month_start = mktime(0, 0, 0, $this_month_num - 1, 1);
        $this->month_end = mktime(0, 0, 0, date("n"), 1) - 1;
        $sql  = " SELECT " .
                "   (10 * SUM(amount) * " . floatval($this->share) . " ) AS sum " .
                " FROM " . ConstDB::TBL_BALANCE_HISTORY .
                " WHERE " .
                "   amount > -0 " .
                "   AND time BETWEEN " . $this->month_start . " AND " . $this->month_end .
                "   AND login NOT IN ('axe00', 'axe01') " .
                " UNION " .
                " SELECT " .
                "   (10 * SUM(amount) * " . floatval($this->share) . " ) AS sum " .
                " FROM " . ConstDB::TBL_BALANCE_HISTORY .
                " WHERE " .
                "   amount > -0 " .
                "   AND login NOT IN ('axe00', 'axe01')";
        $db = new Database("MoneyBox::load");
        $db->query($sql);
        $db->nextRecord();
        $this->sum_month = round($db->f("sum"), 2);
        $db->nextRecord();
        $this->sum_total = round($db->f("sum"), 2);
    }

    public function getMonthSum()
    {
        return $this->sum_month;
    }

    public function getTotalSum()
    {
        return $this->sum_total;
    }

    public function getMonthStart()
    {
        return $this->month_start;
    }

    public function getMonthEnd()
    {
        return $this->month_end;
    }
}

?>
