<?php
/*
 * Class MySQL
 */
class DB_MySQL{

    /* public: connection parameters */
    var $Database = ConstDB::DB_NAME;
    var $Host     = ConstDB::DB_ADDR;
    var $User     = ConstDB::DB_USER;
    var $Password = ConstDB::DB_PASS;

    /* public: configuration parameters */
    var $Auto_Free     = 1;     ## Set to 1 for automatic mysql_free_result()
    var $Debug         = 0;     ## Set to 1 for debugging messages.
    var $Halt_On_Error = "yes"; ## "yes" (halt with message), "no" (ignore errors quietly), "report" (ignore errror, but spit a warning)
    var $PConnect      = 0;     ## Set to 1 to use persistent database connections
    var $Seq_Table     = "db_sequence";

    /* public: result array and current row number */
    var $Record   = array();
    var $Row = array();

    /* public: current error number and error text */
    var $Errno    = 0;
    var $Error    = '';

    /* public: this is an api revision, not a CVS revision. */
    var $type     = "mysql";
    var $revision = "1.2";

    /* private: link and query handles */
    var $Link_ID  = 0;
    var $Query_ID = array();

    var $locked   = false;        ## set to true while we have a lock
    var $query_num = 0;           ## level of qvery
    var $affected_rows = array(); ## affected rows

    // Constructor
    function DB_MySQL (){
    }

    /* public: some trivial reporting */
    function linkId()
    {
        return $this->Link_ID;
    }

    function queryId($query_num = 0)
    {
        return $this->Query_ID[$query_num];
    }

    /* public: connection management */
    function connect()
    {
        /* Handle defaults */
        $Database = $this->Database;
        $Host     = $this->Host;
        $User     = $this->User;
        $Password = $this->Password;

        /* establish connection, select database */
        if ($this->Link_ID == 0) {

            if (!$this->PConnect) {
                $this->Link_ID = @mysql_connect($Host, $User, $Password);
                mysql_query("SET NAMES UTF8");
            } else {
                $this->Link_ID = @mysql_pconnect($Host, $User, $Password);
                mysql_query("SET NAMES UTF8");
            }

            if (!$this->Link_ID) {
                if (function_exists('smError')) {
                    smError (mysql_error());
                }
                return("connect");
            }

            if (!@mysql_select_db($Database,$this->Link_ID)) {
                if (function_exists('smError')) {
                    smError (mysql_error());
                }
                return "select";
            }
        }

        return $this->Link_ID;
    }

    /* public: discard the query result */
    function free($query_num = 0)
    {
        @mysql_free_result($this->Query_ID[$query_num]);
        $this->Query_ID[$query_num] = 0;
        unset($this->Record[$query_num]);
    }

    /* public: perform a query */
    function query($Query_String, $query_num = 0)
    {
        /* No empty queries, please, since PHP4 chokes on them. */
        if ($Query_String == ""){
            /* The empty query string is passed on from the constructor,
            * when calling the class without a query, e.g. in situations
            * like these: '$db = new DB_Sql_Subclass;'
            */
            return 0;
        }

        if (!$this->connect()) {
            return 0; /* we already complained in connect() about that. */
        }

        # New query, discard previous result.
        if ($this->Query_ID[$query_num]) {
            $this->free($query_num);
        }

        if ($this->Debug) {
            printf("Debug: query = %s<br>\n", $Query_String);
        }

        if ($_SERVER['REMOTE_ADDR'] == '0'){
            list($usec, $sec) = explode(" ", microtime());
            $time_start = ((float)$usec + (float)$sec);

            $this->Query_ID[$query_num] = @mysql_query($Query_String,$this->Link_ID);

            list($usec, $sec) = explode(" ", microtime());
            $time_end = ((float)$usec + (float)$sec);
            $time = $time_end - $time_start;
            if ($time > 0.01){
                $fp = fopen("/tmp/mysql/mysql-speed.log", "a+");
                fwrite($fp, '"' . date('H:i:s') . '";"' . $time . '";"' . $query_num . '";"' . $Query_String . "\"\n");
                fclose($fp);
            }
        } else {

            $this->Query_ID[$query_num] = @mysql_query($Query_String,$this->Link_ID);
        }

        $this->Row[$query_num]   = 0;
        $this->Errno = @mysql_errno();
        $this->Error = @mysql_error();
        if ($this->Query_ID[$query_num] == '') {
            $this->halt("Query " . $query_num . " - Invalid SQL: ".$Query_String);
        }

        $this->affected_rows[$query_num] = mysql_affected_rows();
        # Will return nada if it fails. That's fine
        return $this->Query_ID[$query_num];
    }


    function custom_query($Query_String, $query_num = 0)
    {


        /* No empty queries, please, since PHP4 chokes on them. */
        if ($Query_String == ""){
            /* The empty query string is passed on from the constructor,
            * when calling the class without a query, e.g. in situations
            * like these: '$db = new DB_Sql_Subclass;'
            */
            return 0;
        }

        if (!$this->connect()) {
            return 0; /* we already complained in connect() about that. */
        }

        # New query, discard previous result.
        if ($this->Query_ID[$query_num]) {
            $this->free($query_num);
        }

        if ($this->Debug) {
            printf("Debug: query = %s<br>\n", $Query_String);
        }

        $result = @mysql_query($Query_String,$this->Link_ID);
        while ($row = mysql_fetch_assoc($result)) {
            $res[]=$row;
        }

        return  $res;

    }


    /* public: walk result set */
    function nextRecord($query_num = 0)
    {
        if (!$this->Query_ID[$query_num]) {
            return false;
        }

        $this->Record[$query_num] = @mysql_fetch_array($this->Query_ID[$query_num]);
        $this->Row[$query_num]   += 1;
        $this->Errno  = mysql_errno();
        $this->Error  = mysql_error();

        $stat = is_array($this->Record[$query_num]);
        if (!$stat && $this->Auto_Free) {
            $this->free($query_num);
        }

        return $stat;
    }

    /* public: position in result set */
    function seek($query_num = 0, $pos = 0)
    {
        $status = @mysql_data_seek($this->Query_ID[$query_num], $pos);
        if ($status) {
            $this->Row[$query_num] = $pos;
        } else {
            $this->halt("seek($pos) failed: result has ".$this->numRows($query_num)." rows.");

            /* half assed attempt to save the day,
            * but do not consider this documented or even
            * desireable behaviour.
            */
            @mysql_data_seek($this->Query_ID[$query_num], $this->numRows($query_num));
            $this->Row[$query_num] = $this->numRows($query_num);
            return 0;
        }

        return 1;
    }

    /* public: table locking */
    function lock($table, $mode = "write")
    {
        $query = "lock tables ";
        if (is_array($table)) {
            while (list($key,$value) = each($table)) {
                // text keys are "read", "read local", "write", "low priority write"
                if (is_int($key)) {
                    $key = $mode;
                }
                if (strpos($value, ",")) {
                    $query .= str_replace(",", " $key, ", $value) . " $key, ";
                } else {
                    $query .= "$value $key, ";
                }
            }

            $query = substr($query, 0, -2);
        } elseif (strpos($table, ",")) {
            $query .= str_replace(",", " $mode, ", $table) . " $mode";
        } else {
            $query .= "$table $mode";
        }

        if(!$this->query($query)) {
            $this->halt("lock() failed.");
            return false;
        }

        $this->locked = true;
        return true;
    }

    function unlock()
    {
        // set before unlock to avoid potential loop
        $this->locked = false;

        if (!$this->query("unlock tables")) {
            $this->halt("unlock() failed.");
            return false;
        }

        return true;
    }

    /* public: evaluate the result (size, width) */
    function affectedRows ($query_num = 0)
    {
        return $this->affected_rows[$query_num];
    }

    function numRows($query_num = 0)
    {
        return @mysql_num_rows($this->Query_ID[$query_num]);
    }

    function numFields($query_num = 0)
    {
        return @mysql_num_fields($this->Query_ID[$query_num]);
    }

    /* public: shorthand notation */
    function nf($query_num)
    {
        return $this->numRows($query_num);
    }

    function np($query_num)
    {
        print $this->numRows($query_num);
    }

    function f($Name, $query_num = 0)
    {
        if (isset($this->Record[$query_num][$Name]) || is_null($this->Record[$query_num][$Name])) {
            return $this->Record[$query_num][$Name];
        } else {
            $this->halt('','Unknow column : '. $Name . ' . Loock $db->f()');
        }
    }

    function p($Name, $query_num = 0)
    {
        if (isset($this->Record[$query_num][$Name])) {
            print $this->Record[$query_num][$Name];
        }
    }

    /* public: sequence numbers */
    function nextid($seq_name, $query_num = 0)
    {
        /* if no current lock, lock sequence table */
        if (!$this->locked) {
            if ($this->lock($this->Seq_Table)) {
                $locked = true;
            } else {
                $this->halt("cannot lock ".$this->Seq_Table." - has it been created?");
                return 0;
            }
        }

        /* get sequence number and increment */
        $q = sprintf("select nextid from %s where seq_name = '%s'", $this->Seq_Table, $seq_name);

        if (!$this->query($q)) {
            $this->halt('query failed in nextid: '.$q);
            return 0;
        }

        /* No current value, make one */
        if (!$this->nextRecord($query_num)) {
            $currentid = 0;
            $q = sprintf("insert into %s values('%s', %s)", $this->Seq_Table, $seq_name, $currentid);
            if(!$this->query($q)) {
                $this->halt('query failed in nextid: '.$q);
                return 0;
            }
        } else {
            $currentid = $this->f("nextid", $query_num);
        }

        $nextid = $currentid + 1;
        $q = sprintf("update %s set nextid = '%s' where seq_name = '%s'", $this->Seq_Table, $nextid, $seq_name);

        if (!$this->query($q, $query_num)) {
            $this->halt('query failed in nextid: '.$q);
            return 0;
        }

        /* if nextid() locked the sequence table, unlock it */
        if ($locked) {
            $this->unlock();
        }

        return $nextid;
    }

    /* public: return table metadata */
    function metadata($table = "", $full = false, $query_num = 0)
    {
        $count = 0;
        $id    = 0;
        $res   = array();

        /*
         * Due to compatibility problems with Table we changed the behavior
         * of metadata();
         * depending on $full, metadata returns the following values:
         *
         * - full is false (default):
         * $result[]:
         *   [0]["table"]  table name
         *   [0]["name"]   field name
         *   [0]["type"]   field type
         *   [0]["len"]    field length
         *   [0]["flags"]  field flags
         *
         * - full is true
         * $result[]:
         *   ["num_fields"] number of metadata records
         *   [0]["table"]  table name
         *   [0]["name"]   field name
         *   [0]["type"]   field type
         *   [0]["len"]    field length
         *   [0]["flags"]  field flags
         *   ["meta"][field name]  index of field named "field name"
         *   This last one could be used if you have a field name, but no index.
         *   Test:  if (isset($result['meta']['myfield'])) { ...
         */

        // if no $table specified, assume that we are working with a query
        // result

        if ($table) {
            $this->connect($query_num);
            $id = @mysql_list_fields($this->Database, $table);
            if (!$id) {
                $this->halt("Metadata query failed.");
                return false;
            }
        } else {
            $id = $this->Query_ID[$query_num];
            if (!$id) {
                $this->halt("No query specified.");
                return false;
            }
        }

        $count = @mysql_num_fields($id);

        // made this IF due to performance (one if is faster than $count if's)
        if (!$full) {
            for ($i=0; $i<$count; $i++) {
                $res[$i]["table"] = @mysql_field_table ($id, $i);
                $res[$i]["name"]  = @mysql_field_name  ($id, $i);
                $res[$i]["type"]  = @mysql_field_type  ($id, $i);
                $res[$i]["len"]   = @mysql_field_len   ($id, $i);
                $res[$i]["flags"] = @mysql_field_flags ($id, $i);
            }
        } else { // full
            $res["num_fields"]= $count;

            for ($i=0; $i<$count; $i++) {
                $res[$i]["table"] = @mysql_field_table ($id, $i);
                $res[$i]["name"]  = @mysql_field_name  ($id, $i);
                $res[$i]["type"]  = @mysql_field_type  ($id, $i);
                $res[$i]["len"]   = @mysql_field_len   ($id, $i);
                $res[$i]["flags"] = @mysql_field_flags ($id, $i);
                $res["meta"][$res[$i]["name"]] = $i;
            }
        }

        // free the result only if we were called on a table
        if ($table) {
            @mysql_free_result($id);
        }
        return $res;
    }

    /* public: find available table names */
    function tableNames()
    {
        $this->connect($query_num = 0);
        $h = @mysql_query("show tables", $this->Link_ID);
        $i = 0;
        while ($info = @mysql_fetch_row($h)) {
            $return[$i]["table_name"]      = $info[0];
            $return[$i]["tablespace_name"] = $this->Database;
            $return[$i]["database"]        = $this->Database;
            $i++;
        }

        @mysql_free_result($h);
        return $return;
    }

    /* private: error handling */
    function halt($msg, $privat = '')
    {
        $this->Error = @mysql_error($this->Link_ID);
        $this->Errno = @mysql_errno($this->Link_ID);

        if ($this->locked) {
            $this->unlock();
        }

        if ($this->Halt_On_Error == "no") {
            return;
        }

        $this->haltmsg($msg, $privat);

        if ($this->Halt_On_Error != "report") {
            die("Session halted.");
        }
    }

    function haltmsg($msg, $privat = '')
    {
        if ($privat == '') {
            printf("</td></tr></table><b>Database error:</b> %s<br>\n", $msg);
            printf("<b>MySQL Error</b>: %s (%s)<br>\n", $this->Errno, $this->Error);
        } else {
            printf("</td></tr></table><b>MySql error:</b> %s<br>\n", $privat);
        }
    }

    function row ($query_num)
    {
        return $this->Row[$query_num];
    }


    /**
    * @desc Return the ID generated for an AUTO_INCREMENT column by the previous INSERT query
    */
    function insertId()
    {
        return mysql_insert_id($this->Link_ID);
    }

    /**
    * @desc Allow to use this class objects in other classes
    */

    static function &getInstance()
    {
        static $db;
        if (!is_object($db)) {
            $db = new DB_MySQL();
        }
        return $db;
    }
}
?>