<?php

class PacketPortContainer extends ActiveRecordContainer {
    protected $CLASS_NAME = "PacketPort";
    protected $loaded_packets = array();

    public function loadByServer($server_n)
    {
        $server_n = intval($server_n);
        $sql  = $this->getLoadSQL(false, " WHERE `server_n` = $server_n");
        $fname = get_class($this) . "::loadByServer";
        $this->loadBackend($sql, $fname);
    }

    public function loadNonZero()
    {
        $sql  = $this->getLoadSQL(false, " WHERE (`camd_port` != 0 OR `newcamd_port` != 0)");
        $fname = get_class($this) . "::loadNonZero";
        $this->loadBackend($sql, $fname);
    }

    protected function loadBackend($sql, $fname)
    {
        $db_fields = $this->getDbFieldNames();
        $pri_key_field = $this->getPriKeyField();
        $db = new Database($fname);
        $db->query($sql);
        while ($db->nextRecord()){
            $data = array();
            $pri_key_value = $db->f($pri_key_field);
            $packet_id = $db->f('packet_id');
            $server_n = $db->f('server_n');
            foreach ($db_fields as $field){
                $data[$field] = $db->f($field);
            }
            eval("\$this->objects[\$server_n][\$packet_id] = new " . $this->CLASS_NAME . "();");
            $this->loaded_packets[$packet_id] = true;
            $this->objects[$server_n][$packet_id]->setData($data);
            $this->user_logins[$login] = true;
        }
    }
    
    public function getPackets()
    {
        return array_keys($this->loaded_packets);
    }

    public function updateAndSave($data_array)
    {
        $sql_ins =  " INSERT INTO " . $this->getTableName() .
                    "   (packet_id, server_n, camd_port, newcamd_port) " .
                    " VALUES ";
        $first = true;
        foreach ($data_array as $server_n => $server_data)
        {
            foreach ($server_data as $packet_id => $packet_data)
            {
                if ($first)
                {
                    $first = false;
                }
                else
                {
                    $sql_ins .= ", ";
                }
                $camd_port = intval($packet_data['camd']);
                $newcamd_port = intval($packet_data['newcamd']);
                $sql_ins .= "($packet_id, $server_n, $camd_port, $newcamd_port)";
            }
        }
        $db = new Database(get_class($this) . ":updateAndSave");
        $db->query("TRUNCATE TABLE " . $this->getTableName());
        $db->query($sql_ins);
    }
}

?>