<?php

class PageHandlers {
    public static function stdPageHandler ($file, $get, $rowsPerPage, $numRows, $currentPage, $jsvars = null)
    {
        if (!empty($jsvars)){
            $params = array();
            $js_function = $jsvars[0];
            for ($i = 1; $i < count($jsvars); $i++) {
                $params[] = $jsvars[$i];
            }
            $js_href = "JavaScript:" . $js_function . "('" . implode("','", $params) . "')";
            //JavaScript:setReport('url','',''...)
            unset ($params);
            $js = true;
        }
        // Variablen
        $ssn = Session::getInstance();
        $lang = &Language::getInstance();
        $tr = '.';
        if (empty ($currentPage)) $currentPage = 1;
        // Back
        $numPages = ceil($numRows / $rowsPerPage);
        // get
        $get = (!empty($get)) ? "&".$get : "";
        if ($js) {
            $get = str_replace('&', '&amp;', $get);
        }
        if($currentPage > 1) {
            $back = $currentPage - 1;
            if ($js) {
                $href = str_replace('$url', $ssn->Url($file . "?page=1".$get), $js_href);
            } else {
                $href = $ssn->Url($file . "?page=1".$get);
            }

            $pages = "<a class=\"PagesHandlerLink\" href=\"" . $href ."\">&lt;&lt</a> <a class=\"PagesHandlerLink\" href=\"".$href."\">" . $lang->Get('pages_handler_back') . "</a> <font FACE=\"Symbol\">&#183;</font> ";
        }

        // Pages
        $bSub = ($numPages - $currentPage < 5) ? 10 -($numPages - $currentPage) : 5;
        $eSub = (10 - $currentPage > 5) ? 10 - $currentPage : 5;
        $begin = ($currentPage - $bSub < 1) ? 1 : $currentPage - $bSub;
        $end   = ($currentPage + $eSub > $numPages) ? $numPages : ($currentPage + $eSub);

        for($i = $begin; $i <= $end; $i++){
            if ($js){
                $href = str_replace('$url', $ssn->Url($file."?page=".$i.$get), $js_href);
            } else {
                $href = $ssn->Url($file."?page=".$i.$get);
            }

            if ($i == $end)      $pages .= ($i != $currentPage) ? " <a class=\"PagesHandlerLink\" href=\"".$href."\">$i</a> " : " <font FACE=\"Symbol\">&#183;</font> [$i/$numPages]";
            elseif ($i > 1)      $pages .= ($i != $currentPage) ? " <a class=\"PagesHandlerLink\" href=\"".$href."\">$i</a> " : " <font FACE=\"Symbol\">&#183;</font> [$i/$numPages] <font FACE=\"Symbol\">&#183;</font> ";
            else                 $pages .= ($i != $currentPage) ? " <a class=\"PagesHandlerLink\" href=\"".$href."\">$i</a> " : "[$i/$numPages] <font FACE=\"Symbol\">&#183;</font> ";
            if ($i < $end && $i != $currentPage && $i != $currentPage - 1) $pages .= ' <font FACE=\"Symbol\">&#183;</font> ';
        }
        // Next
        if($numPages > $currentPage) {
            $next = $currentPage + 1;
            if ($js){
                $href = str_replace('$url', $ssn->Url($file."?page=".$next.$get), $js_href);
                $href_end = str_replace('$url', $ssn->Url($file."?page=".$numPages.((!empty($get)) ? "&#038;".$get : "")), $js_href);

            } else {
                $href = $ssn->Url($file."?page=".$next.$get);
                $href_end = $ssn->Url($file."?page=".$numPages.((!empty($get)) ? "&#038;".$get : ""));
            }

            $pages .= " <font FACE=\"Symbol\">&#183;</font> <a class=\"PagesHandlerLink\" href=\"".$href."\">" . $lang->Get('pages_handler_next') . "</a> <a class=\"PagesHandlerLink\" href=\"".$href_end."\">&gt;&gt;</a>";
        }
        $pages = "<div class=\"handlerFeld\">".$pages."</div>";
        return $pages;
    }

    /*
    Pages Handler - with rewrite_mode
    */
    public static function rewritePageHandler ($prefix, $nav, $rowsPerPage, $numRows, $currentPage)
    {
        $ssn =& Session::getInstance();
        $lang   =& Language::getInstance();
        # Variablen
        $tr = '.';
        if (empty ($currentPage)) $currentPage = 1;
        # Back
        $numPages = ceil($numRows / $rowsPerPage);
        if($currentPage > 1){
            $back = $currentPage - 1;
            if ($back >= 1)
                    $pages = "<a class=\"PagesHandlerLink\" href=\"" . $ssn->Url($prefix."/".$nav.$tr."1.htm") . "\">&lt;&lt</a> <a class=\"PagesHandlerLink\" href=\"" . $ssn->Url($prefix."/".$nav.$tr.$back.".htm")."\">" . $lang->Get('pages_handler_back') . "</a> <font FACE=\"Symbol\">&#183;</font>";
                else  $pages = "<a class=\"PagesHandlerLink\" href=\"" . $ssn->Url($prefix."/".$nav.$tr."1.htm") . "\">&lt;&lt</a> <a class=\"PagesHandlerLink\" href=\"" . $ssn->Url($prefix."/".$nav.".htm")."\">" . $lang->Get('pages_handler_back') . "</a> <font FACE=\"Symbol\">&#183;</font>";
        }
        # Pages
        $bSub = ($numPages - $currentPage < 5) ? 10 -($numPages - $currentPage) : 5;
        $eSub = (10 - $currentPage > 5) ? 10 - $currentPage : 5;
        $begin = ($currentPage - $bSub < 1) ? 1 : $currentPage - $bSub;
        $end   = ($currentPage + $eSub > $numPages) ? $numPages : ($currentPage + $eSub);

        for($i = $begin; $i <= $end; $i++){
            if ($i == $end)      $pages .= ($i != $currentPage) ? " <a class=\"PagesHandlerLink\" href=\"" . $ssn->Url($prefix."/".$nav.$tr.$i.".htm") . "\">$i</a> " : "<font FACE=\"Symbol\">&#183;</font> [$i/$numPages]";
            elseif ($i > 1)      $pages .= ($i != $currentPage) ? " <a class=\"PagesHandlerLink\" href=\"" . $ssn->Url($prefix."/".$nav.$tr.$i.".htm") . "\">$i</a> " : "<font FACE=\"Symbol\">&#183;</font> ($i/$numPages) <font FACE=\"Symbol\">&#183;</font>";
            else                 $pages .= ($i != $currentPage) ? " <a class=\"PagesHandlerLink\" href=\"" . $ssn->Url($prefix."/".$nav.$tr.$i.".htm") . "\">$i</a> "        : "[$i/$numPages] <font FACE=\"Symbol\">&#183;</font>";
            if ($i < $end && $i != $currentPage && $i != $currentPage - 1) $pages .= ' <font FACE=\"Symbol\">&#183;</font>';
        }
        # Next
        if($numPages > $currentPage) {
            $next = $currentPage + 1;
                $pages .= "<font FACE=\"Symbol\">&#183;</font> <a class=\"PagesHandlerLink\" href=\"" . $ssn->Url($prefix."/".$nav.$tr.$next.".htm") . "\">" . $lang->Get('pages_handler_next') . "</a> <a class=\"PagesHandlerLink\" href=\"" . $ssn->Url($prefix."/".$nav.$tr.$numPages.".htm") . "\">&gt;&gt;</a>";
        }
        $pages = "<div class=\"handlerFeld\">" . $pages . " </div>";
        return $pages;
    }

    // page handler width javasript
    public static function stdPageHandlerJs ($file, $get, $rowsPerPage, $numRows, $currentPage)
    {
        // Variablen
        $ssn = Session::getInstance();
        $lang   =& Language::getInstance();
        $tr = '.';
        if (empty ($currentPage)) $currentPage = 1;
        // Back
        $numPages = ceil($numRows / $rowsPerPage);
        // get
        $get = (!empty($get)) ? '&'.$get : "";

        if($currentPage > 1){
            $back = $currentPage - 1;
            $pages = "<a class=\"PagesHandlerLink\" href=\"#page\" onClick=\"setReport('" . $ssn->Url($file . "?page=1".$get) . "','','commentss')\">&lt;&lt</a> <a class=\"PagesHandlerLink\" href=\"#page\" onClick=\"setReport('".$ssn->Url($file."?page=".$back.$get)."','','commentss')\">" . $lang->Get('pages_handler_back') . "</a> <font FACE=\"Symbol\">&#183;</font> ";
        }
        // Pages
        $bSub = ($numPages - $currentPage < 5) ? 10 -($numPages - $currentPage) : 5;
        $eSub = (10 - $currentPage > 5) ? 10 - $currentPage : 5;
        $begin = ($currentPage - $bSub < 1) ? 1 : $currentPage - $bSub;
        $end   = ($currentPage + $eSub > $numPages) ? $numPages : ($currentPage + $eSub);

        for($i = $begin; $i <= $end; $i++){
            if ($i == $end)      $pages .= ($i != $currentPage) ? " <a class=\"PagesHandlerLink\" href=\"#page\" onClick=\"setReport('".$ssn->Url($file."?page=".$i.$get)."','','commentss')\">$i</a> " : " <font FACE=\"Symbol\">&#183;</font> [$i/$numPages]";
            elseif ($i > 1)      $pages .= ($i != $currentPage) ? " <a class=\"PagesHandlerLink\" href=\"#page\" onClick=\"setReport('".$ssn->Url($file."?page=".$i.$get)."','','commentss')\">$i</a> " : " <font FACE=\"Symbol\">&#183;</font> [$i/$numPages] <font FACE=\"Symbol\">&#183;</font> ";
            else                 $pages .= ($i != $currentPage) ? " <a class=\"PagesHandlerLink\" href=\"#page\" onClick=\"setReport('".$ssn->Url($file."?page=".$i.$get)."','','commentss')\">$i</a> " : "[$i/$numPages] <font FACE=\"Symbol\">&#183;</font> ";
            if ($i < $end && $i != $currentPage && $i != $currentPage - 1) $pages .= ' <font FACE=\"Symbol\">&#183;</font> ';
        }
        // Next
        if($numPages > $currentPage) {
            $next = $currentPage + 1;
            $pages .= " <font FACE=\"Symbol\">&#183;</font> <a class=\"PagesHandlerLink\" href=\"#page\" onClick=\"setReport('".$ssn->Url($file."?page=".$next.$get)."','','commentss')\">" . $lang->Get('pages_handler_next') . "</a> <a class=\"PagesHandlerLink\" href=\"#page\" onClick=\"setReport('".$ssn->Url($file."?page=".$numPages.$get)."','','commentss')\">&gt;&gt;</a>";
        }
        $pages = "<div class=\"handlerFeld\">".$pages."</div>";
        return $pages;
    }
}

?>