<?php

class ServerLoad extends LoadableObject
{
    public $serverLoad = array();
    protected $table_name = ConstDB::TBL_SERVER_LOAD;

    public function ServerLoad()
    {
        $this->loaded = false;
    }

    public function load()
    {
        $db = new Database(get_class($this) . ":load");
        $sql  = " SELECT * " .
                " FROM " . $this->table_name;
        $db->query($sql);
        while ($db->nextRecord())
        {
            $this->serverLoad[$db->f('server_n')] = $db->f('user_count');
        }
        $this->loaded = true;
    }

    public function getAll()
    {
        return $this->serverLoad;
    }

    public function get($server_n)
    {
        return $this->serverLoad[$server_n];
    }

    public function setData($data)
    { 
      $this->serverLoad[key($data)] = intval($data[key($data)]);
    }

    public function save()
    {
        $db = new Database(get_class($this) . ":save");
        $sql  = " REPLACE " .
                " INTO " . $this->table_name .
                "   (server_n, user_count) " .
                " VALUES ";
        $first = true;
        foreach ($this->serverLoad as $server_n => $user_count)
        {
            if ($first)
                $first = false;
            else
                $sql .= ", ";
            $sql .= "($server_n, $user_count)";
        }
        $db->query($sql);
    }

    public function getLeastLoadedServer()
    {
        $db = new Database(get_class($this) . ":getLeastLoadedServer");
        $sql  = " SELECT server_n " .
                " FROM " . $this->table_name .
                " ORDER BY user_count ASC " .
                " LIMIT 1";
        $db->query($sql);
        if ($db->nextRecord())
            return $db->f("server_n");
        return 1;
    }
}

?>
