<?
class Session {
    var $usesCookies = false;
    // Session name
    var $sessionName = '';
    // Debug
    var $debug = true;

    function Session($sessionName = ConstSession::SESSION_NAME, $disableTransSID = true, $debug = false, $seite = null, $ssn_id = null)
    {
        if ($disableTransSID){
            ini_set("session.use_trans_sid","0");
        }
        if (!$this->debug) {
            $this->debug = $debug;
        }

        $this->sessionName = isset($sessionName) ? $sessionName : session_name();
        session_name($this->sessionName);
        @session_start();

        // Forced logout when login from 2 browsers
        if ($_SESSION['forced_logout'] == 1 && !isset($_GET['forced_logout'])) {
            Member::forcedLogout($this);
        }

        if (isset($ssn_id) && strlen($ssn_id) > 20) {
            session_id($ssn_id);
        }
        if (strlen(session_id()) <= 20){
	        mt_srand ((double)microtime() * 1000000);
	        session_id(md5(uniqid(mt_rand())));
        }

        $this->usesCookies = ( isset($_COOKIE[$this->sessionName]) && @strlen($_COOKIE[$this->sessionName]) > 20);
    }

    function sendNoCacheHeader()
    {
        header("Expires: Sat, 05 Aug 2006 12:00:00 GMT");
        header("Last-Modified: " . gmdate("D, d M Y H:i:s") . " GMT");
        header("Cache-Control: no-cache, must-revalidate, post-check=0, pre-check=0");
        header("Pragma: no-cache");
    }

    function sendCacheHeader()
    {
        header("Last-Modified: " . gmdate("D, d M Y H:i:s") . " GMT");
        session_cache_limiter('public');
    }

    function redirectTo($pathInfo, $add3W = false)
    {
        if (!preg_match("/^http(s{0,1}):\/\//", $pathInfo)) {
            if ($pathInfo[0] != "/") {
                $pathInfo = substr($_SERVER['SCRIPT_NAME'], 0, strrpos($_SERVER['SCRIPT_NAME'],"/")+1) . $pathInfo;
            }
            $port    = !preg_match("/^(80|443)$/", $_SERVER['SERVER_PORT'], $portMatch)
                       ? ":".$_SERVER['SERVER_PORT']
                       : "";

            $server_path = $_SERVER['SERVER_NAME'] . $port . $this->url($pathInfo);
            // Redirect
            header("Location: "
                    .(($portMatch[1] == 443) ? "https://" : "http://")
                    .$server_path);
        } else {
            // Redirect
            header("Location: " . $this->url($pathInfo));
        }
        exit;
    }

    function removeTrail($pathInfo)
    {
        $dummy = preg_match("/(.*)(?<!&|\?)/", $pathInfo, $match);
        return $match[0];
    }

    function url($pathInfo)
    {
        if ($this->usesCookies || ini_get("session.use_trans_sid")) {
            return $pathInfo;
        }

        $dummyArray = explode("#",$pathInfo);
        $pathInfo = $dummyArray[0];

        $pathInfo = preg_replace("/[?|&]" . $this->sessionName . "=[^?|&]*/","", $pathInfo);

        if (preg_match("/&/", $pathInfo) && !preg_match("/\?/", $pathInfo)) {
            $pathInfo = preg_replace("/&/","?",$pathInfo,1);
        }

        $pathInfo = $this->removeTrail($pathInfo);

        $pathInfo .= preg_match("/\?/", $pathInfo) ? "&" : "?";
        $pathInfo .= $this->sessionName . "=" . session_id();

        $pathInfo .= isset($dummyArray[1]) ? ("#" . $dummyArray[1]) : "";

        return $pathInfo;
    }

    function getSsn () {
        return $pathInfo = $this->sessionName . "=" . session_id();
    }

    function hidden()
    {
        if ($this->usesCookies || ini_get("session.use_trans_sid")) return "";
        return '<INPUT type="hidden" name="' . $this->sessionName . '" value="'.session_id().'">';
    }

    function debug ($str = '')
    {
        error_log(date ("[d.m.Y H:i:s]") . " - '" . $_SERVER['SERVER_NAME'] .
        $_SERVER['SCRIPT_NAME'] . "' " . $str . ".\n", 3 ,"/tmp/session_error.log");
        $query = $_SERVER['QUERY_STRING'] != "" ? "?" . $_SERVER['QUERY_STRING'] : "";
        header("Status: 302 Found");
        $this->redirectTo($_SERVER['SCRIPT_NAME'].$query); // Script terminiert
    }

    static function &getInstance($ssnName = ConstSession::SESSION_NAME)
    {
        static $ssn;
        if (!is_object($ssn)) {
            $ssn = new Session($ssnName);
        }
        return $ssn;
    }
}
?>