<?php

class UserPacketGroupContainer extends ActiveRecordContainer {
    protected $CLASS_NAME = "UserPacketGroup";
    protected $user_logins = array();

    public function loadActive()
    {
        $sql  = $this->getLoadSQL(false, " WHERE time_till > '" . time() . "'");
        $fname = get_class($this) . "::loadActive";
        $this->loadBackend($sql, $fname);
    }

    public function loadActiveByNames($names)
    {
        $conditions =   " WHERE time_till > " . time() . " " .
                        "   AND packet_group IN ('" . implode("', '", $names) . "')";
        $sql  = $this->getLoadSQL(false, $conditions);
        $fname = get_class($this) . "::loadActiveByNames";
        $this->loadBackend($sql, $fname);
    }

    protected function loadBackend($sql, $fname)
    {
        $db_fields = $this->getDbFieldNames();
        $pri_key_field = $this->getPriKeyField();
        $db = new Database($fname);
        $db->query($sql);
        while ($db->nextRecord()){
            $data = array();
            $pri_key_value = $db->f($pri_key_field);
            $packet_group = $db->f('packet_group');
            $login = $db->f('login');
            foreach ($db_fields as $field){
                $data[$field] = $db->f($field);
            }
            if (empty($this->objects[$login][$packet_group]))
            $this->objects[$login][$packet_group] = array();
            eval("\$this->objects[\$login][\$packet_group][] = new " . $this->CLASS_NAME . "();");
            $this->objects[$login][$packet_group][count($this->objects[$login][$packet_group])-1]->setData($data);
            $this->user_logins[$login] = true;
        }
    }

    public function getLogins()
    {
        return array_keys($this->user_logins);
    }

    public function loadActiveByUser($user_login)
    {
        $conditions =   " WHERE login       = '" . mysql_real_escape_string($user_login) . "'" .
                        "   AND time_till   > '" . time() . "'";
        $sql  = $this->getLoadSQL(false, $conditions);
        $fname = get_class($this) . "::loadActiveByUser";
        $this->loadBackend($sql, $fname);
    }

    public function deleteByGroups($packet_groups, $login)
    {
        $db = new Database(get_class($this) . "::deleteByPackets");
        $sql =  " DELETE FROM " . $this->getTableName() .
                " WHERE " .
                "       packet_group IN " . $this->createPriKeyStr($packet_groups) .
                "   AND login = '" . mysql_real_escape_string($login) . "' ";
        $db->query($sql);
        return $db->affectedRows();
    }

	public function loadUsersWithEndSoon($period)
	{
		$time_period_starts = mktime() + 3600*24*($period-1);
		$time_period_ends = mktime() + 3600*24*$period;
		$sql  = $this->getLoadSQL(false, " WHERE time_till > ".$time_period_starts." and time_till < " . $time_period_ends . " ");
		$fname = get_class($this) . "::loadUsersWithEndSoon";
		$this->loadBackend($sql, $fname);
		$users = array();
		$db = new Database($fname);
		foreach($this->user_logins as $login => $objects_count)
		{	$db->query("SELECT * FROM users WHERE login = '".mysql_escape_string($login)."' ");
			$db->nextRecord();
			$user["login"]=$db->f('login');
			$user["email"]=$db->f('email');
			$user["subscribed_notices"]=$db->f('subscribed_notices');
			if(!empty($user["email"])) {
				$packets = array();
				foreach($this->objects[$login] as $packet_group => $objects) {	
					for($i=0;$i<count($objects);$i++) 
						$packets[]=$objects[$i]->db_values;
				}
				$user["packets"]=$packets;
				$users[$login]=$user;
			}
		}
		return $users;
	}
}

?>