<?php

class UserPacketGroupContainer extends ActiveRecordContainer {
    protected $CLASS_NAME = "UserPacketGroup";
    protected $user_logins = array();

    public function loadActive()
    {
        $sql  = $this->getLoadSQL(false, " WHERE time_till > '" . time() . "'");
        $fname = get_class($this) . "::loadActive";
        $this->loadBackend($sql, $fname);
    }

    public function loadActiveByNames($names)
    {
        $conditions =   " WHERE time_till > " . time() . " " .
                        "   AND packet_group IN ('" . implode("', '", $names) . "')";
        $sql  = $this->getLoadSQL(false, $conditions);
        $fname = get_class($this) . "::loadActiveByNames";
        $this->loadBackend($sql, $fname);
    }
	
	public function loadBylogins($login)
    {
        $conditions =   " WHERE login = '" . $login . "'";
        $sql  = $this->getLoadSQL(false, $conditions);
        $fname = get_class($this) . "::loadByNames";
        $this->loadBackend($sql, $fname);
    }
	
	public function loadActiveWithPacketsForDaysLast($days)
	{
		$this_day_num = date("j");
		$days_unix_time = mktime(0, 0, 0, date("n"), $this_day_num + $days);
		$conditions = " WHERE time_till > " . time() . " ".
					  " AND time_till < " . $days_unix_time;

		$sql  = $this->getLoadSQL(false, $conditions);
        $fname = get_class($this) . "::loadActiveWithPacketsForDaysLast";
        $this->loadBackend($sql, $fname);
	}

    protected function loadBackend($sql, $fname)
    {
        $db_fields = $this->getDbFieldNames();
        $pri_key_field = $this->getPriKeyField();
        $db = new Database($fname);
        $db->query($sql);
        while ($db->nextRecord()){
            $data = array();
            $pri_key_value = $db->f($pri_key_field);
            $packet_group = $db->f('packet_group');
            $login = $db->f('login');
            foreach ($db_fields as $field){
                $data[$field] = $db->f($field);
            }
            eval("\$this->objects[\$login][\$packet_group] = new " . $this->CLASS_NAME . "();");
            $this->objects[$login][$packet_group]->setData($data);
            $this->user_logins[$login] = true;
        }
    }

    public function getLogins()
    {
        return array_keys($this->user_logins);
    }

    public function loadActiveByUser($user_login)
    {
        $conditions =   " WHERE login       = '" . mysql_real_escape_string($user_login) . "'" .
                        "   AND time_till   > '" . time() . "'";
        $sql  = $this->getLoadSQL(false, $conditions);
        $fname = get_class($this) . "::loadActiveByUser";
        $this->loadBackend($sql, $fname);
    }

    public function deleteByGroups($packet_groups, $login)
    {
        $db = new Database(get_class($this) . "::deleteByPackets");
        $sql =  " DELETE FROM " . $this->getTableName() .
                " WHERE " .
                "       packet_group IN " . $this->createPriKeyStr($packet_groups) .
                "   AND login = '" . mysql_real_escape_string($login) . "' ";
        $db->query($sql);
        return $db->affectedRows();
    }

}

?>