function loadData(id) {
    var element = document.getElementById(id)
	
    var onLoaded = function(data) {
        element.value = data;
    }
 
    var onLoadError = function(error) {
        var msg = "Ошибка "+error.errcode
        if (error.message) msg = msg + ' :'+error.message
        alert(msg)
    }
 
    var showLoading = function(on) {
	if(on)
		element.value = "Загрузка...";
    }
 
    var onSuccess = function(data) {
        if (!data.errcode) {
            onLoaded(data)
            showLoading(false)        
        } else {
            showLoading(false)
            onLoadError(data)            
        }
    }
 
    var onAjaxError = function(xhr, status){
        showLoading(false)
        var errinfo = { errcode: status }
        if (xhr.status != 200) {
            // может быть статус 200, а ошибка
            // из-за некорректного JSON
            errinfo.message = xhr.statusText
        } else {
            errinfo.message = 'Некорректные данные с сервера'
        }
        onLoadError(errinfo)
    }
 
 
    return {
        load: function(url) {
            showLoading(true)
 
            while (element.firstChild) {
                element.removeChild(element.firstChild)
            }
            $.ajax({ // для краткости - jQuery
                url: url,
                dataType: "html",
                success: onSuccess,
                error: onAjaxError,
                cache: false,
		timeout: 90000
            })
        }
    }
}